# coding: utf-8
'''
增加功能：
    增加背景音乐
'''
import pygame,time,random
#导入一个精灵包
from pygame.sprite import Sprite
SCREEN_WIDTH=830
SCREEN_HEIGHT=700
#传入我方坦克的位置
MYTANK_HEIGHT=500
MYTANK_WIDTH=500
WIN_BGCOLOR=pygame.Color(0,0,0)
TEXT_COLOR=pygame.Color(255,0,0)

#定义一个基类
class BaseItem(Sprite):
    def __init__(self, color, width, height):
        # Call the parent class (Sprite) constructor
        pygame.sprite.Sprite.__init__(self)

class MainGame():
    window=None
    my_tank=None
    #创建敌方坦克的列表
    enemyTankList=[]
    #创建敌方坦克的数量
    enemyTankCount=5
    #存储方子弹的列表
    myBulletList=[]
    #存储敌方子弹列表
    enemyBulletList=[]
    #存储爆炸对象列表
    explodeList=[]
    #存储墙壁的列表
    wallList=[]
    def __init__(self):
        pass
    #开始游戏
    def startGame(self):
        #加载主窗口
        pygame.display.init()
        #显示窗口的大小(初始化要显示的窗口或屏幕)（MainGame.window返回的是一个Surface对象）
        MainGame.window=pygame.display.set_mode([SCREEN_WIDTH,SCREEN_HEIGHT])
        # 设置窗口的标题
        pygame.display.set_caption("杜尚江-坦克大战")
        #无限重生我方坦克
        self.creatMyTank()
        #初始化敌方坦克,并将坦克加载到列表中
        self.creatEnemyTank()
        #初始化墙壁
        self.creatWall()
        #重复加载窗口
        while True:
            time.sleep(0.02)
            # 给当前窗口填充颜色(填充背景颜色移动不能放在文字绘制的后面，不然会把文字给覆盖掉)
            MainGame.window.fill(WIN_BGCOLOR)
            #重复加载getEvent()窗口（为了实现关闭窗口）
            self.getEvent()
            #绘制文字，也绘制一次，加载一次
            MainGame.window.blit(self.getSuFaceText("敌方坦克剩余数量：%d"%len(MainGame.enemyTankList)),(500,670))
            #判断我的坦克是否还存活着、
            if MainGame.my_tank and MainGame.my_tank.live:
                # 让坦克一直显示
                MainGame.my_tank.displayTank()
            else:
                #删除我方坦克、
                del MainGame.my_tank
                MainGame.my_tank=None
            #循环遍历敌方坦克
            self.blitEnemyTank()
            #循环遍历我方子弹
            self.blitMyBullet()
            #循环遍历敌方子弹列表
            self.blitEnemyBullet()
            #循环遍历爆炸列表，展示爆炸效果
            self.blitExplode()
            #循环遍历墙壁
            self.blitWall()
            if MainGame.my_tank and MainGame.my_tank.live:
                # 调用坦克移动方法
                if MainGame.my_tank.stop:
                    MainGame.my_tank.move()
                    #检测我方坦克是否与敌方坦克发生碰撞
                    MainGame.my_tank.myTank_hit_enemyTank()
                    #检测我方坦克是否与墙壁发生碰撞
                    MainGame.my_tank.hitWall()
            pygame.display.update()#让窗口一直显示


    #循环遍历墙壁
    def blitWall(self):
        for wall in MainGame.wallList:
            #如果墙壁存在
            if wall.live:
                #调用显示墙壁的方法
                wall.displayWall()
            #如果不存在，则从列表中移除
            else:
                MainGame.wallList.remove(wall)

    #创建墙壁
    def creatWall(self):
        for i in range(7):
            wall=Wall(140*i,400)
            #将创建的墙壁添加到列表中
            MainGame.wallList.append(wall)
    #无限重生我方坦克
    def creatMyTank(self):
        MainGame.my_tank = MyTanK(MYTANK_WIDTH, MYTANK_HEIGHT)
        #创建music
        music=Music("img/wa.mp3")
        #播放音乐
        music.playMusic()

    # 初始化敌方坦克,并将坦克加载到列表中
    def creatEnemyTank(self):
        top = 100
        for i in range(MainGame.enemyTankCount):
            left = random.randint(0, 500)
            speed = random.randint(1, 4)
            enemy = EnemyTanK(left, top, speed)
            # 存储到列表
            MainGame.enemyTankList.append(enemy)

    # 循环遍历敌方坦克列表，展示敌方坦克
    def blitEnemyTank(self):
        for enemyTank in MainGame.enemyTankList:
           #判断当前坦克是否活着
            if enemyTank.live:
                enemyTank.displayTank()
                # 使坦克移动
                # enemyTank.move()
                enemyTank.randMove()
                #检测敌方坦克是否碰撞到墙壁
                enemyTank.hitWall()
                if MainGame.my_tank and MainGame.my_tank.live:
                    # 检测敌方坦克是否与我方坦克发生碰撞
                    enemyTank.enemyTank_hit_myTank()
            #     # 发射子弹
            #     enemyBullet = enemyTank.shot()
            #     # 敌方子弹是否是None，如果不为None则添加到敌方子弹列表中
            #     if enemyBullet:
            #         # 将敌方子弹存储到敌方子弹列表中
            #         MainGame.enemyBulletList.append(enemyBullet)
            # # 如果死了，则移除
            else:
                MainGame.enemyTankList.remove(enemyTank)

    # 循环遍历我方坦克的子弹
    def blitMyBullet(self):
        for myBullet in MainGame.myBulletList:
            if myBullet.live:
                myBullet.displayBullet()
                myBullet.move()
                #判断我方子弹是否与敌方坦克发射碰撞
                myBullet.myBullet_hit_enemyTank()
                #当我方子弹碰撞到敌方坦克时播放爆炸音乐
                music=Music("img/fire.wav")
                music.playMusic()
                # 检测我方子弹是否与墙壁碰撞
                myBullet.hitWall()
            else:
                MainGame.myBulletList.remove(myBullet)

        # 循环遍历敌方子弹列表
    def blitEnemyBullet(self):
        for enemyBullet in MainGame.enemyBulletList:
            if enemyBullet.live:
                enemyBullet.displayBullet()
                enemyBullet.move()
                #调用我方子弹与敌方坦克碰撞的方法
                enemyBullet.enemyBullet_hit_myTank()
                #检测敌方子弹是否与墙壁碰撞
                enemyBullet.hitWall()
            else:
                MainGame.enemyBulletList.remove(enemyBullet)

    ##循环遍历爆炸列表，展示爆炸效果
    def blitExplode(self):
        for explode in MainGame.explodeList:
            if explode.live:
                #展示
                explode.displayExplode()
            else :
                #移除爆炸
                MainGame.explodeList.remove(explode)

    # 在一个新的Suface上绘制文字
    def getSuFaceText(self, text):
        # 初始化字体模块
        pygame.font.init()
        # 获取所有可用字体
        # fonts=pygame.font.get_fonts()
        # print(fonts)
        # 根据系统字体创建一个Font对象
        font = pygame.font.SysFont("Kaiti", 20,True,True)
        # 在新创建的Surface上绘制文本(绘制文本信息)
        textSuFace = font.render(text, True, TEXT_COLOR)
        return textSuFace

    #获取事件（用于控制每一个事件）
    def getEvent(self):
        #获取所有事件
        EventList=pygame.event.get()
        #循环遍历事件
        for list in EventList:
            if list.type==pygame.QUIT:
                self.endGame()
                # exit()
                #调用的是KEYDOWN
            if list.type==pygame.KEYDOWN:
                #如果坦克不存在了，
                if not MainGame.my_tank :
                    # 按下的是ESC键则重生我方坦克
                    if list.key == pygame.K_ESCAPE:
                        self.creatMyTank()

                if MainGame.my_tank and MainGame.my_tank.live:
                    if list.key == pygame.K_LEFT:
                        # 增加移动方法direction
                        MainGame.my_tank.direction = "L"
                        # MainGame.my_tank.move()
                        # 修改坦克的开关
                        MainGame.my_tank.stop = True
                        print("按下了左建")
                    elif list.key == pygame.K_RIGHT:
                        # 增加移动方法
                        MainGame.my_tank.direction = "R"
                        # MainGame.my_tank.move()
                        # 修改坦克的开关
                        MainGame.my_tank.stop = True
                        print("按下了右键")
                    elif list.key == pygame.K_UP:
                        # 增加移动方法
                        MainGame.my_tank.direction = "U"
                        # MainGame.my_tank.move()
                        # 修改坦克的开关
                        MainGame.my_tank.stop = True
                        print("按下了上键")
                    elif list.key == pygame.K_DOWN:
                        # 增加移动方法
                        MainGame.my_tank.direction = "D"
                        # MainGame.my_tank.move()aa
                        # 修改坦克的开关
                        MainGame.my_tank.stop = True
                        print("按下了下键")
                    elif list.key == pygame.K_a:
                        print("按下了a键，发射子弹")
                        # 创建我方坦克发射的子弹(一次最多只能发射3颗子弹)
                        if len(MainGame.myBulletList) < 3:
                            myBullet = Bullet(MainGame.my_tank)
                            MainGame.myBulletList.append(myBullet)
                            #我方子弹添加音效
                            music=Music("img/hit.wav")
                            music.playMusic()
            if list.type==pygame.KEYUP:
                #如果按下的是上下左右键时停止
                if list.key==pygame.K_UP or list.key==pygame.K_LEFT or list.key==pygame.K_RIGHT or list.key==pygame.K_DOWN:
                    if MainGame.my_tank and MainGame.my_tank.live:
                        MainGame.my_tank.stop = False

    #结束游戏
    def endGame(self):
        print("谢谢使用")
        exit()

#主坦克类（我方坦克，敌方坦克）
class MainTanK(BaseItem):
    #添加距离左边left,右边right
    def __init__(self,left,top):
        #添加方向
        self.images={
                "U":pygame.image.load("img/p1tankU.gif"),
                "L":pygame.image.load("img/p1tankL.gif"),
                "D":pygame.image.load("img/p1tankD.gif"),
                "R":pygame.image.load("img/p1tankR.gif")
        }
        #方向
        self.direction="D"
        #根据当前图片的方向获取图片(SuFace)
        self.image=self.images[self.direction]
        #根据图片获取区域
        self.rect=self.image.get_rect()
        #设置区域的位置
        self.rect.left=left
        self.rect.top=top
        #给坦克一个速度speed
        self.speed = 5
        #坦克移动的开关
        self.stop=False
        #判断是否活着
        self.live=True
        #新增属性替换到原来坐标
        self.oldLeft=self.rect.left
        self.oldTop=self.rect.top

    #移动
    def move(self):
        #移动后记录原来的坐标
        self.oldLeft = self.rect.left
        self.oldTop = self.rect.top
        #坦克移动
        if self.direction =="L":
            if self.rect.left>0:
                self.rect.left-=self.speed
        elif self.direction =="R":
            if self.rect.left<SCREEN_WIDTH-60:
                self.rect.left+=self.speed
        elif self.direction == "U":
            if self.rect.top>0:
                self.rect.top -=self.speed
        elif self.direction == "D":
            if self.rect.top<SCREEN_HEIGHT-60:
                self.rect.top += self.speed

    # 射击
    def shot(self):
        return Bullet(self)

    #碰撞之前的坐标
    def stay(self):
        self.rect.left=self.oldLeft
        self.rect.top=self.oldTop

    #检测坦克是否碰撞到墙
    def hitWall(self):
        for wall in MainGame.wallList:
            #如果碰撞到墙
            if pygame.sprite.collide_rect(self,wall):
                #将坐标设置为移动之前的坐标
                self.stay()

    #显示坦克的方法
    def displayTank(self):
        #调用展示的对象
        self.image=self.images[self.direction]
        #使用blit()调用
        MainGame.window.blit(self.image,self.rect)

#我方坦克
class MyTanK(MainTanK):
    def __init__(self,left,top):
        super(MyTanK,self).__init__(left,top)

    #检测我方坦克是否与敌方坦克发生碰撞
    def myTank_hit_enemyTank(self):
        #循环遍历敌方坦克
        for enemyTank in MainGame.enemyTankList:
            if pygame.sprite.collide_rect(self,enemyTank):
                self.stay()

#敌方坦克
class EnemyTanK(MainTanK):
    #初敌方坦克
    def __init__(self,left,top,speed):
        #调用父类的初始化方法
        super(EnemyTanK,self).__init__(left,top)
        #添加方向图片
        self.images={
            "U" : pygame.image.load("img/enemy1U.gif"),
            "L":pygame.image.load("img/enemy1L.gif"),
            "D":pygame.image.load("img/enemy1D.gif"),
            "R":pygame.image.load("img/enemy1R.gif")
        }
        #方向
        self.direction=self.randDirection()
        #根据方向获取图片
        self.image = self.images[self.direction]
        #区域
        self.rect = self.image.get_rect()
        #设置top和left的值
        self.rect.left = left
        self.rect.top = top
        #speed
        self.speed = speed
        #移动开关
        self.flag = True
        #移动的步数
        self.step=70

    #检测敌方坦克是否与我方坦克发生碰撞
    def enemyTank_hit_myTank(self):
        if pygame.sprite.collide_rect(self,MainGame.my_tank):
            self.stay()

    #随机生成图片的方向
    def randDirection(self):
        num = random.randint(1, 4)
        if num == 1:
            return "U"
        elif num == 2:
            return "L"
        elif num == 3:
            return "D"
        elif num == 4:
            return "R"

    #增加随机移动的方法
    def randMove(self):
        if self.step <=0:
            #随机修改方向
            self.direction=self.randDirection()
            #修改方向后还原步数
            self.step=70
        else:
            self.move()
            self.step -= 1
    #重新shot方法
    def shot(self):
        #随后生成100以类的数
        num=random.randint(1,100)
        if num < 10:
            return Bullet(self)
#子弹类
class Bullet(BaseItem):
    def __init__(self,tank):
        #加载图片
        self.image=pygame.image.load("img/enemymissile.gif")
        #坦克的方向决定子弹的方向
        self.direction=tank.direction
        #获取区域
        self.rect=self.image.get_rect()

        #子弹的left和top与方向的left和top有关
        if self.direction == 'U':
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top - self.rect.height
        elif self.direction == 'D':
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.height
        elif self.direction == 'L':
            self.rect.left = tank.rect.left - self.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2
        elif self.direction == 'R':
            self.rect.left = tank.rect.left + tank.rect.width
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2

        #子弹的速度
        self.speed = 6
        #判断子弹的状态，如果子碰到墙壁，则死亡
        self.live=True

    #移动
    def move(self):
        if self.direction == "U":
            if self.rect.top>0:
                self.rect.top-=self.speed
            else:
                #修改子弹的状态，（死亡）
                self.live=False
        elif self.direction == "D":
            if self.rect.top+self.rect.height<SCREEN_HEIGHT:
                self.rect.top+=self.speed
            else:
                # 修改子弹的状态，（死亡）
                self.live = False
        elif self.direction == "L":
            if self.rect.left>0:
                self.rect.left-=self.speed
            else:
                # 修改子弹的状态，（死亡）
                self.live = False
        elif self.direction == "R":
            if self.rect.left+self.rect.height<SCREEN_WIDTH:
                self.rect.left+=self.speed
            else:
                # 修改子弹的状态，（死亡）
                self.live = False

    #子弹是否碰撞到墙壁
    def hitWall(self):
        #循环遍历墙壁列表
        for wall in MainGame.wallList:
            #如果子弹碰撞到了墙壁
            if pygame.sprite.collide_rect(self,wall):
                #修改子弹状态
                self.live=False
                #修改墙壁状态
                wall.hp-=1
                if wall.hp<0:
                    wall.live=False

    #显示子弹的方法
    def displayBullet(self):
        #将图片的surface加载到窗口
        MainGame.window.blit(self.image,self.rect)

    #增加一个我方子弹与敌方坦克是否方式碰撞的方法
    def myBullet_hit_enemyTank(self):
        #循环遍历敌方坦克，判断是否发生碰撞
        for enemyTank in MainGame.enemyTankList:
            if pygame.sprite.collide_rect(enemyTank,self):
                #修改敌方坦克的状态和我方子弹的状态
                enemyTank.live=False
                self.live=False
                #创建爆炸对象，
                explode=Explode(enemyTank)
                # 将爆炸对象添加到列表中
                MainGame.explodeList.append(explode)

    # 敌方子弹与我方坦克的碰撞
    def enemyBullet_hit_myTank(self):
        if MainGame.my_tank and MainGame.my_tank.live:
            if pygame.sprite.collide_rect(MainGame.my_tank, self):
                # 产生爆炸对象
                explode = Explode(MainGame.my_tank)
                # 将爆炸对象添加到列表中
                MainGame.explodeList.append(explode)
                # 修改敌方坦克与我方子弹的状态
                self.live = False
                MainGame.my_tank.live = False
#墙壁类
class Wall():
    def __init__(self,left,top):
        #加载墙壁图片
        self.image=pygame.image.load("img/steels.gif")
        #获取图片区域
        self.rect=self.image.get_rect()
        #设置图片的top和left
        self.rect.left=left
        self.rect.top=top
        #墙壁是否存活
        self.live=True
        #墙壁的生命值
        self.hp=5

    #碰到不能通过
    def displayWall(self):
        #展示墙壁的方法
        MainGame.window.blit(self.image,self.rect)


#爆炸类
class Explode():
    def __init__(self,tank):
        #爆炸的位置由子弹打到的坦克的位置决定
        self.rect=tank.rect

        #加载爆炸效果的图片
        self.images=[
            pygame.image.load("img/blast0.gif"),
            pygame.image.load("img/blast1.gif"),
            pygame.image.load("img/blast2.gif"),
            pygame.image.load("img/blast3.gif"),
            pygame.image.load("img/blast4.gif")
        ]
        self.step=0
        #加载图片
        self.image=self.images[self.step]
        #判断是否活着
        self.live=True

    #被子弹打到会爆炸
    def displayExplode(self):
        if self.step<5:
            #根据索引获取爆炸效果
            self.image=self.images[self.step]
            self.step+=1
            # 添加到主窗口
            MainGame.window.blit( self.image,self.rect)
        else:
            #修改活着的状态
            self.live=False
            self.step=0

#音响类
class Music():
    def __init__(self,fileName):
        self.fileName=fileName
        #初始化混合器
        pygame.mixer.init()
        #加载
        pygame.mixer.music.load(self.fileName)
    #播放背景音乐
    def playMusic(self):
        # 调用播放音乐
        pygame.mixer.music.play()
        # pygame.mixer.music.set_pos(60.0)
        # pygame.mixer.music.unpause()

if __name__=="__main__":
    MainGame().startGame()
    MainGame().getSuFaceText()